Attribute VB_Name = "Consts"
'==========================================================
' Copyright (C) 2005 YOKOGAWA ELECTRIC CORPORATION
'
'   ALL RIGHTS RESERVED BY YOKOGAWA ELECTRIC CORPORATION.
'THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT
'WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
'INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
'MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
'
'                            YOKOGAWA ELECTRIC CORPORATION
'==========================================================
Option Explicit

Type SYSTEMTIME ' 16 Bytes
  wYear As Integer
  wMonth As Integer
  wDayOfWeek As Integer
  wDay As Integer
  wHour As Integer
  wMinute As Integer
  wSecond As Integer
  wMilliseconds As Integer
End Type
Public Const EM_LINESCROLL As Long = 182

Public Declare Sub memcpy Lib "kernel32" Alias "RtlMoveMemory" _
(ByVal Dest As Long, ByVal Src As Long, ByVal ByteLen As Long)
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Sub GetLocalTime Lib "kernel32" _
(lpSystemTime As SYSTEMTIME)

'#--------------------------------------------#
'### Var Definations ###
'#--------------------------------------------#
Private ErrorInfo(14)               As String

Private rs232baud(5)                As String
Private rs232port(4)                As String

Private rangeListAuto               As String
Private rangeListDirect             As String
Private rangeListSensor             As String

Private voltageList(2, 12)          As String
Private currentList(4, 12)          As String

Private eList(9)                    As String
Private oList(102)                  As String
Private updateRateList(7)           As String

Private nList(53)                   As String
Private hlist(37)                   As String

Private id As Long
Private element_last As Integer
Private crest_factor As String
'#--------------------------------------------#

'#--------------------------------------------#
'### Properties ###
'#--------------------------------------------#
Public Property Get tmError(i As Integer) As String
  tmError = ErrorInfo(i)
End Property

Public Property Get BaudList(i As Integer) As String
  BaudList = rs232baud(i)
End Property
Public Property Get PortList(i As Integer) As String
  PortList = rs232port(i)
End Property

Public Property Get VoltList(i As Integer, j As Integer) As String
  VoltList = voltageList(i, j)
End Property
Public Property Get CurrList(i As Integer, j As Integer) As String
  CurrList = currentList(i, j)
End Property
Public Property Get AutoRange() As String
  AutoRange = rangeListAuto
End Property
Public Property Get Direct() As String
  Direct = rangeListDirect
End Property
Public Property Get Sensor() As String
  Sensor = rangeListSensor
End Property
Public Property Get ElementList(i As Integer) As String
  ElementList = eList(i)
End Property
Public Property Get OrderList(i As Integer) As String
  OrderList = oList(i)
End Property
Public Property Get RateList(i As Integer) As String
  RateList = updateRateList(i)
End Property

Public Property Get NmlList(i As Integer) As String
  NmlList = nList(i)
End Property
Public Property Get HmncList(i As Integer) As String
  HmncList = hlist(i)
End Property

Public Property Get CommID() As Long
  CommID = id
End Property
Public Property Let CommID(ByVal newID As Long)
  id = newID
End Property

Public Property Get LastElement() As Long
  LastElement = element_last
End Property
Public Property Let LastElement(ByVal newMax As Long)
  element_last = newMax
End Property

Public Property Get CrestFactor() As String
  CrestFactor = crest_factor
End Property
Public Property Let CrestFactor(ByVal value As String)
  crest_factor = value
End Property
'#--------------------------------------------#


'#--------------------------------------------#
'### Initialize Vars ###
'#--------------------------------------------#
Public Function commConstInit()
  rs232baud(0) = "1200"
  rs232baud(1) = "2400"
  rs232baud(2) = "4800"
  rs232baud(3) = "9600"
  rs232baud(4) = "19200"
  
  rs232port(0) = "COM1"
  rs232port(1) = "COM2"
  rs232port(2) = "COM3"
  rs232port(3) = "COM4"
End Function

'#--------------------------------------------#
'### constInit ###
'#--------------------------------------------#
Public Function constInit()

  '===========================
  'Error Code from Tmctl
  '===========================
  'Error Number  Problem                                Solutions
  ErrorInfo(0) = ""
  ErrorInfo(1) = "Device not found"               '   2  1 Check the wiring.
  ErrorInfo(2) = "Connection to device failed"    '   4  2 Check the wiring.
  ErrorInfo(3) = "Device not connected"           '   8  3 Connect the device using the initialization function.
  ErrorInfo(4) = "Device already connected"       '  16  4 Two connections cannot be opened.
  ErrorInfo(5) = "Incompatible PC"                '  32  5 Check the hardware you are using.
  ErrorInfo(6) = "Illegal parameter"              '  64  6 Check parameter type etc.
  ErrorInfo(7) = ""
  ErrorInfo(8) = "Send error"                     ' 256  8 Check the wiring, address, and ID.
  ErrorInfo(9) = "Receive error"                  ' 512  9 Check whether an error occurred on the device.
  ErrorInfo(10) = "Received data not block data" '1024 10
  ErrorInfo(11) = ""
  ErrorInfo(12) = "System error"                 '4096 11 There is a problem with the operating environment.
  ErrorInfo(13) = "Illegal device ID"            '8192 12 Use the ID of the device acquired by the initialization function.

  '===========================
  'Voltage Range List
  '===========================
  'CrestFactor = 3
  voltageList(0, 0) = "1.5V"
  voltageList(0, 1) = "3V"
  voltageList(0, 2) = "6V"
  voltageList(0, 3) = "10V"
  voltageList(0, 4) = "15V"
  voltageList(0, 5) = "30V"
  voltageList(0, 6) = "60V"
  voltageList(0, 7) = "100V"
  voltageList(0, 8) = "150V"
  voltageList(0, 9) = "300V"
  voltageList(0, 10) = "600V"
  voltageList(0, 11) = "1000V"
  'CrestFactor = 6
  voltageList(1, 0) = "0.75V"
  voltageList(1, 1) = "1.5V"
  voltageList(1, 2) = "3V"
  voltageList(1, 3) = "5V"
  voltageList(1, 4) = "7.5V"
  voltageList(1, 5) = "15V"
  voltageList(1, 6) = "30V"
  voltageList(1, 7) = "50V"
  voltageList(1, 8) = "75V"
  voltageList(1, 9) = "150V"
  voltageList(1, 10) = "300V"
  voltageList(1, 11) = "500V"
  
  rangeListAuto = "AUTO"
  rangeListDirect = "DIRECT"
  rangeListSensor = "SENSOR"
  
  '===========================
  'Current Range List
  '===========================
  'CrestFactor = 3, Direct
  currentList(0, 0) = "10mA"
  currentList(0, 1) = "20mA"
  currentList(0, 2) = "50mA"
  currentList(0, 3) = "100mA"
  currentList(0, 4) = "200mA"
  currentList(0, 5) = "500mA"
  currentList(0, 6) = "1A"
  currentList(0, 7) = "2A"
  currentList(0, 8) = "5A"
  currentList(0, 9) = "10A"
  currentList(0, 10) = "20A"
  currentList(0, 11) = "50A"
  
  'CrestFactor = 6, Direct
  currentList(1, 0) = "5mA"
  currentList(1, 1) = "10mA"
  currentList(1, 2) = "25mA"
  currentList(1, 3) = "50mA"
  currentList(1, 4) = "100mA"
  currentList(1, 5) = "250mA"
  currentList(1, 6) = "500mA"
  currentList(1, 7) = "1A"
  currentList(1, 8) = "2.5A"
  currentList(1, 9) = "5A"
  currentList(1, 10) = "10A"
  currentList(1, 11) = "25A"
  
  'CrestFactor = 3, Sensor
  currentList(2, 0) = "50mV"
  currentList(2, 1) = "100mV"
  currentList(2, 2) = "250mV"
  currentList(2, 3) = "500mV"
  currentList(2, 4) = "1V"
  currentList(2, 5) = "2.5V"
  currentList(2, 6) = "5V"
  currentList(2, 7) = "10V"
  currentList(2, 8) = ""
  currentList(2, 9) = ""
  currentList(2, 10) = ""
  currentList(2, 11) = ""
  
  'CrestFactor = 6, Sensor
  currentList(3, 0) = "25mV"
  currentList(3, 1) = "50mV"
  currentList(3, 2) = "125mV"
  currentList(3, 3) = "250mV"
  currentList(3, 4) = "500mV"
  currentList(3, 5) = "1.25V"
  currentList(3, 6) = "2.5V"
  currentList(3, 7) = "5V"
  currentList(3, 8) = ""
  currentList(3, 9) = ""
  currentList(3, 10) = ""
  currentList(3, 11) = ""
  
  '===========================
  'Update Rate List
  '===========================
  updateRateList(0) = "50ms"
  updateRateList(1) = "100ms"
  updateRateList(2) = "200ms"
  updateRateList(3) = "500ms"
  updateRateList(4) = "1s"
  updateRateList(5) = "2s"
  updateRateList(6) = "5s"
  
  '===========================
  'Element List
  '===========================
  eList(0) = "1"
  eList(1) = "2"
  eList(2) = "3"
  eList(3) = "4"
  eList(4) = "5"
  eList(5) = "6"
  eList(6) = "SGMA"
  eList(7) = "SGMB"
  eList(8) = "SGMC"
  
  '===========================
  'Order List
  '===========================
  oList(0) = "TOTAL"
  oList(1) = "DC"
  oList(2) = "1"
  oList(3) = "2"
  oList(4) = "3"
  oList(5) = "4"
  oList(6) = "5"
  oList(7) = "6"
  oList(8) = "7"
  oList(9) = "8"
  oList(10) = "9"
  oList(11) = "10"
  oList(12) = "11"
  oList(13) = "12"
  oList(14) = "13"
  oList(15) = "14"
  oList(16) = "15"
  oList(17) = "16"
  oList(18) = "17"
  oList(19) = "18"
  oList(20) = "19"
  oList(21) = "20"
  oList(22) = "21"
  oList(23) = "22"
  oList(24) = "23"
  oList(25) = "24"
  oList(26) = "25"
  oList(27) = "26"
  oList(28) = "27"
  oList(29) = "28"
  oList(30) = "29"
  oList(31) = "30"
  oList(32) = "31"
  oList(33) = "32"
  oList(34) = "33"
  oList(35) = "34"
  oList(36) = "35"
  oList(37) = "36"
  oList(38) = "37"
  oList(39) = "38"
  oList(40) = "39"
  oList(41) = "40"
  oList(42) = "41"
  oList(43) = "42"
  oList(44) = "43"
  oList(45) = "44"
  oList(46) = "45"
  oList(47) = "46"
  oList(48) = "47"
  oList(49) = "48"
  oList(50) = "49"
  oList(51) = "50"
  oList(52) = "51"
  oList(53) = "52"
  oList(54) = "53"
  oList(55) = "54"
  oList(56) = "55"
  oList(57) = "56"
  oList(58) = "57"
  oList(59) = "58"
  oList(60) = "59"
  oList(61) = "60"
  oList(62) = "61"
  oList(63) = "62"
  oList(64) = "63"
  oList(65) = "64"
  oList(66) = "65"
  oList(67) = "66"
  oList(68) = "67"
  oList(69) = "68"
  oList(70) = "69"
  oList(71) = "70"
  oList(72) = "71"
  oList(73) = "72"
  oList(74) = "73"
  oList(75) = "74"
  oList(76) = "75"
  oList(77) = "76"
  oList(78) = "77"
  oList(79) = "78"
  oList(80) = "79"
  oList(81) = "80"
  oList(82) = "81"
  oList(83) = "82"
  oList(84) = "83"
  oList(85) = "84"
  oList(86) = "85"
  oList(87) = "86"
  oList(88) = "87"
  oList(89) = "88"
  oList(90) = "89"
  oList(91) = "90"
  oList(92) = "91"
  oList(93) = "92"
  oList(94) = "93"
  oList(95) = "94"
  oList(96) = "95"
  oList(97) = "96"
  oList(98) = "97"
  oList(99) = "98"
  oList(100) = "99"
  oList(101) = "100"

  '===========================
  'Normal Data Function List
  '///to get more about the
  '///command of a function,
  '///see 5.5 in the
  '///communication manual
  '===========================
  nList(0) = "URMS" '"Urms"
  nList(1) = "UMN" '"Umean"
  nList(2) = "UDC" '"Udc"
  nList(3) = "UAC" '"Uac"
  nList(4) = "IRMS" '"Irms"
  nList(5) = "IMN" '"Imean"
  nList(6) = "IDC" '"Idc"
  nList(7) = "IAC" '"Iac"
  nList(8) = "P"
  nList(9) = "S"
  nList(10) = "Q"
  nList(11) = "LAMBDA" '"LAMBDA"
  nList(12) = "PHI" '"PHI"
  nList(13) = "FU" '"FreqU"
  nList(14) = "FI" '"FreqI"
  nList(15) = "UPPEAK" '"U +peak"
  nList(16) = "UMPEAK" '"U -peak"
  nList(17) = "IPPEAK" '"i +peak"
  nList(18) = "IMPEAK" '"i -peak"
  nList(19) = "CFU" '"CfU"
  nList(20) = "CFI" '"CfI"
  nList(21) = "FFU" '"FfU"
  nList(22) = "FFI" '"FfI"
  nList(23) = "Z"
  nList(24) = "RS" '"Rs"
  nList(25) = "XS" '"Xs"
  nList(26) = "RP" '"Rp"
  nList(27) = "XP" '"Xp"
  nList(28) = "PC" '"Pc"
  nList(29) = "TIME" '"i -Time"
  nList(30) = "WH" '"Wp"
  nList(31) = "WHP" '"Wp+"
  nList(32) = "WHM" '"Wp-"
  nList(33) = "AH" '"q"
  nList(34) = "AHP" '"q+"
  nList(35) = "AHM" '"q-"
  'NO ELEMENT SETTINGS BELOW
  nList(36) = "ETA" '"ETA"
  nList(37) = "SETA" '"1/ETA"
  '(Motor)
  nList(38) = "PM" '"Pm"
  nList(39) = "TORQUE" '"Torque"
  nList(40) = "SPEED" '"Speed"
  nList(41) = "SLIP" '"Slip"
  nList(42) = "SYNC" '"Sync"
  nList(43) = "MAETA" '"ETAmA"
  nList(44) = "MBETA" '"ETAmB"
  '(DELTA1~DELTA4)
  nList(45) = "DURMS" '"DELTAUrms"
  nList(46) = "DUMN" '"DELTAUmn"
  nList(47) = "DUDC" '"DELTAUdc"
  nList(48) = "DUAC" '"DELTAUac"
  nList(49) = "DIRMS" '"DELTAIrms"
  nList(50) = "DIMN" '"DELTAImn"
  nList(51) = "DIDC" '"DELTAIdc"
  nList(52) = "DIAC" '"DELTAIac"
  '============================
  'Harmonics Data Function List
  '============================
  'E1~E9,ORDER
  hlist(0) = "U"
  hlist(1) = "I"
  hlist(2) = "P"
  hlist(3) = "S"
  hlist(4) = "Q"
  hlist(5) = "LAMBDA" '"LAMBDA"
  hlist(6) = "PHI" '"PHI"
  hlist(7) = "PHIU" '"PHIU"
  hlist(8) = "PHII" '"PHII"
  hlist(9) = "Z"
  hlist(10) = "RS" '"Rs"
  hlist(11) = "XS" '"Xs"
  hlist(12) = "RP" '"Rp"
  hlist(13) = "XP" '"Xp"
  hlist(14) = "UHDF" '"Uhdf"
  hlist(15) = "IHDF" '"Ihdf"
  hlist(16) = "PHDF" '"Phdf"
  'NO ORDER SETTINGS
  hlist(17) = "UTHD" '"Uthd"
  hlist(18) = "ITHD" '"Ithd"
  hlist(19) = "PTHD" '"Pthd"
  hlist(20) = "UTHF" '"Uthf"
  hlist(21) = "ITHF" '"Ithf"
  hlist(22) = "UTIF" '"Utif"
  hlist(23) = "ITIF" '"Itif"
  hlist(24) = "HVF" '"Hvf"
  hlist(25) = "HCF" '"Hcf"
  hlist(26) = "FU" '"fU"
  hlist(27) = "FI" '"fI"
  'E7~E9
  hlist(28) = "PHI_U1U2" '"PHIU1-U2"
  hlist(29) = "PHI_U1U3" '"PHIU1-U3"
  hlist(30) = "PHI_U1I1" '"PHIU1-I1"
  hlist(31) = "PHI_U1I2" '"PHIU1-I2"
  hlist(32) = "PHI_U1I3" '"PHIU1-I3"

  hlist(33) = "F1" '"F1"
  hlist(34) = "F2" '"F2"
  hlist(35) = "F3" '"F3"
  hlist(36) = "F4" '"F4"
End Function
